#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_pressed()
{
    QString fname = QFileDialog::getOpenFileName(this, "Open", qApp->applicationDirPath(), "Images (*.jpg *.bmp *.tif *.png)");
    if(!QFile(fname).exists())
        return;

    QImage image(fname);
    ui->label->setPixmap(QPixmap::fromImage(image));
}

void MainWindow::on_pushButton_2_pressed()
{
    QImage image = ui->label->pixmap()->toImage();
    if(image.isNull())
        return;

    QImage edges = ui->label->pixmap()->toImage();

    QMatrix3x3 kernel;
    kernel(0, 0) = -1; kernel(0, 1) = -1; kernel(0, 2) = -1;
    kernel(1, 0) = -1; kernel(1, 1) = 8; kernel(1, 2) = -1;
    kernel(2, 0) = -1; kernel(2, 1) = -1; kernel(2, 2) = -1;

    for(int i=1; i<image.width()-1; i++)
    {
        for(int j=1; j<image.height()-1; j++)
        {
            image.setPixel(i, j, qGray(image.pixel(i, j)));
        }
    }

    for(int i=1; i<image.width()-1; i++)
    {
        for(int j=1; j<image.height()-1; j++)
        {
            float v = 0;

            // *****************************************************
            v =
                    kernel(0, 0) * qGray(image.pixel(i+1, j+1)) +
                    kernel(0, 1) * qGray(image.pixel(i, j+1)) +
                    kernel(0, 2) * qGray(image.pixel(i-1, j+1)) +

                    kernel(1, 0) * qGray(image.pixel(i+1, j)) +
                    kernel(1, 1) * qGray(image.pixel(i, j)) +
                    kernel(1, 2) * qGray(image.pixel(i-1, j)) +

                    kernel(2, 0) * qGray(image.pixel(i+1, j-1)) +
                    kernel(2, 1) * qGray(image.pixel(i, j-1)) +
                    kernel(2, 2) * qGray(image.pixel(i-1, j-1));

            edges.setPixel(i,j, qRgb(v, v, v));

        }
    }

    ui->label_2->setPixmap(QPixmap::fromImage(edges));
}
